/**************************************************************************
 * Umlaut Plugin Copyright (C) 2007-2008 Mikhail Polenin                  *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This plugin is licensed under the Open Software License 3.0            *
 * Please read the license before making a modification to this plugin.   *
 * Failure to follow the terms of the license will have severe            *
 * consequences                                                           *
 **************************************************************************/

#include "HeXHubSDK.h"
#include <string>

const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	HexHub Hex;
	if(Hex.Initialize(HexGetFunction) == false) return 0;

	return "Umlaut Plugin version 0.1 by The Architect";
}


BOOL HEXHUBAPI onChatMessage(SDWORD userId,const char *lpBuffer,int bufferSize, userFloodInfo *uFL, floodDefInfo *fDI)
{
	if(lpBuffer[0] == '$') return true;

	char nick[40];
	memset(nick, 0, 40);
	std::string buffer = lpBuffer;

	if(HexHub::Users::NickFromId(userId, nick))
	{
		std::string::size_type st;
		int off = 0;
		int i = 0;

		for (i=0; buffer[i] != 0; i++) {
			if (buffer[i] == '>') {
				off = i;
				break;
			}
		}

		if(buffer[off+2] == '!') return true;

		int iz0r = 0;

		for(iz0r=0;iz0r!=buffer.length();iz0r++)
		{
			if(buffer[iz0r] == 'o') { buffer.replace(iz0r, 1, ""); continue; }
			if(buffer[iz0r] == 'u') { buffer.replace(iz0r, 1, ""); continue; }
			if(buffer[iz0r] == 'a') { buffer.replace(iz0r, 1, ""); continue; }
			if(buffer[iz0r] == 'O') { buffer.replace(iz0r, 1, ""); continue; }
			if(buffer[iz0r] == 'U') { buffer.replace(iz0r, 1, ""); continue; }
			if(buffer[iz0r] == 'A') { buffer.replace(iz0r, 1, ""); continue; }
			if(buffer[iz0r] == 'B' || buffer[iz0r] == 'b') { buffer.replace(iz0r, 1, ""); continue; }
		}

		HexHub::Data::SendToAll(buffer.c_str(), buffer.length());

		return false;
	}
	return true;
}